git-fetch.shon commit git-svn: fix several small bugs, enable branch optimization (cf7424b)
   1#!/bin/sh
   2#
   3
   4USAGE='<fetch-options> <repository> <refspec>...'
   5. git-sh-setup
   6. git-parse-remote
   7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
   8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
   9
  10LF='
  11'
  12IFS="$LF"
  13
  14no_tags=
  15tags=
  16append=
  17force=
  18verbose=
  19update_head_ok=
  20exec=
  21upload_pack=
  22while case "$#" in 0) break ;; esac
  23do
  24        case "$1" in
  25        -a|--a|--ap|--app|--appe|--appen|--append)
  26                append=t
  27                ;;
  28        --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
  29        --upload-pa|--upload-pac|--upload-pack)
  30                shift
  31                exec="--exec=$1" 
  32                upload_pack="-u $1"
  33                ;;
  34        -f|--f|--fo|--for|--forc|--force)
  35                force=t
  36                ;;
  37        -t|--t|--ta|--tag|--tags)
  38                tags=t
  39                ;;
  40        -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
  41                no_tags=t
  42                ;;
  43        -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
  44        --update-he|--update-hea|--update-head|--update-head-|\
  45        --update-head-o|--update-head-ok)
  46                update_head_ok=t
  47                ;;
  48        -v|--verbose)
  49                verbose=Yes
  50                ;;
  51        -k|--k|--ke|--kee|--keep)
  52                keep=--keep
  53                ;;
  54        -*)
  55                usage
  56                ;;
  57        *)
  58                break
  59                ;;
  60        esac
  61        shift
  62done
  63
  64case "$#" in
  650)
  66        test -f "$GIT_DIR/branches/origin" ||
  67                test -f "$GIT_DIR/remotes/origin" ||
  68                        die "Where do you want to fetch from today?"
  69        set origin ;;
  70esac
  71
  72remote_nick="$1"
  73remote=$(get_remote_url "$@")
  74refs=
  75rref=
  76rsync_slurped_objects=
  77
  78if test "" = "$append"
  79then
  80        : >"$GIT_DIR/FETCH_HEAD"
  81fi
  82
  83append_fetch_head () {
  84    head_="$1"
  85    remote_="$2"
  86    remote_name_="$3"
  87    remote_nick_="$4"
  88    local_name_="$5"
  89    case "$6" in
  90    t) not_for_merge_='not-for-merge' ;;
  91    '') not_for_merge_= ;;
  92    esac
  93
  94    # remote-nick is the URL given on the command line (or a shorthand)
  95    # remote-name is the $GIT_DIR relative refs/ path we computed
  96    # for this refspec.
  97
  98    # the $note_ variable will be fed to git-fmt-merge-msg for further
  99    # processing.
 100    case "$remote_name_" in
 101    HEAD)
 102        note_= ;;
 103    refs/heads/*)
 104        note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
 105        note_="branch '$note_' of " ;;
 106    refs/tags/*)
 107        note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
 108        note_="tag '$note_' of " ;;
 109    refs/remotes/*)
 110        note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
 111        note_="remote branch '$note_' of " ;;
 112    *)
 113        note_="$remote_name of " ;;
 114    esac
 115    remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
 116        remote_="$remote_1_"
 117    note_="$note_$remote_"
 118
 119    # 2.6.11-tree tag would not be happy to be fed to resolve.
 120    if git-cat-file commit "$head_" >/dev/null 2>&1
 121    then
 122        headc_=$(git-rev-parse --verify "$head_^0") || exit
 123        echo "$headc_   $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
 124        [ "$verbose" ] && echo >&2 "* committish: $head_"
 125        [ "$verbose" ] && echo >&2 "  $note_"
 126    else
 127        echo "$head_    not-for-merge   $note_" >>"$GIT_DIR/FETCH_HEAD"
 128        [ "$verbose" ] && echo >&2 "* non-commit: $head_"
 129        [ "$verbose" ] && echo >&2 "  $note_"
 130    fi
 131    if test "$local_name_" != ""
 132    then
 133        # We are storing the head locally.  Make sure that it is
 134        # a fast forward (aka "reverse push").
 135        fast_forward_local "$local_name_" "$head_" "$note_"
 136    fi
 137}
 138
 139fast_forward_local () {
 140    mkdir -p "$(dirname "$GIT_DIR/$1")"
 141    case "$1" in
 142    refs/tags/*)
 143        # Tags need not be pointing at commits so there
 144        # is no way to guarantee "fast-forward" anyway.
 145        if test -f "$GIT_DIR/$1"
 146        then
 147                if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
 148                then
 149                        [ "$verbose" ] && echo >&2 "* $1: same as $3"
 150                else
 151                        echo >&2 "* $1: updating with $3"
 152                fi
 153        else
 154                echo >&2 "* $1: storing $3"
 155        fi
 156        git-update-ref "$1" "$2"
 157        ;;
 158
 159    refs/heads/* | refs/remotes/*)
 160        # $1 is the ref being updated.
 161        # $2 is the new value for the ref.
 162        local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
 163        if test "$local"
 164        then
 165            # Require fast-forward.
 166            mb=$(git-merge-base "$local" "$2") &&
 167            case "$2,$mb" in
 168            $local,*)
 169                if test -n "$verbose"
 170                then
 171                        echo >&2 "* $1: same as $3"
 172                fi
 173                ;;
 174            *,$local)
 175                echo >&2 "* $1: fast forward to $3"
 176                echo >&2 "  from $local to $2"
 177                git-update-ref "$1" "$2" "$local"
 178                ;;
 179            *)
 180                false
 181                ;;
 182            esac || {
 183                echo >&2 "* $1: does not fast forward to $3;"
 184                case ",$force,$single_force," in
 185                *,t,*)
 186                        echo >&2 "  forcing update."
 187                        git-update-ref "$1" "$2" "$local"
 188                        ;;
 189                *)
 190                        echo >&2 "  not updating."
 191                        exit 1
 192                        ;;
 193                esac
 194            }
 195        else
 196            echo >&2 "* $1: storing $3"
 197            git-update-ref "$1" "$2"
 198        fi
 199        ;;
 200    esac
 201}
 202
 203case "$update_head_ok" in
 204'')
 205        orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 206        ;;
 207esac
 208
 209# If --tags (and later --heads or --all) is specified, then we are
 210# not talking about defaults stored in Pull: line of remotes or
 211# branches file, and just fetch those and refspecs explicitly given.
 212# Otherwise we do what we always did.
 213
 214reflist=$(get_remote_refs_for_fetch "$@")
 215if test "$tags"
 216then
 217        taglist=`IFS="  " &&
 218                  git-ls-remote $upload_pack --tags "$remote" |
 219                  while read sha1 name
 220                  do
 221                        case "$name" in
 222                        *^*) continue ;;
 223                        esac
 224                        if git-check-ref-format "$name"
 225                        then
 226                            echo ".${name}:${name}"
 227                        else
 228                            echo >&2 "warning: tag ${name} ignored"
 229                        fi
 230                  done`
 231        if test "$#" -gt 1
 232        then
 233                # remote URL plus explicit refspecs; we need to merge them.
 234                reflist="$reflist$LF$taglist"
 235        else
 236                # No explicit refspecs; fetch tags only.
 237                reflist=$taglist
 238        fi
 239fi
 240
 241fetch_main () {
 242  reflist="$1"
 243  refs=
 244
 245  for ref in $reflist
 246  do
 247      refs="$refs$LF$ref"
 248
 249      # These are relative path from $GIT_DIR, typically starting at refs/
 250      # but may be HEAD
 251      if expr "z$ref" : 'z\.' >/dev/null
 252      then
 253          not_for_merge=t
 254          ref=$(expr "z$ref" : 'z\.\(.*\)')
 255      else
 256          not_for_merge=
 257      fi
 258      if expr "z$ref" : 'z+' >/dev/null
 259      then
 260          single_force=t
 261          ref=$(expr "z$ref" : 'z+\(.*\)')
 262      else
 263          single_force=
 264      fi
 265      remote_name=$(expr "z$ref" : 'z\([^:]*\):')
 266      local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
 267
 268      rref="$rref$LF$remote_name"
 269
 270      # There are transports that can fetch only one head at a time...
 271      case "$remote" in
 272      http://* | https://*)
 273          if [ -n "$GIT_SSL_NO_VERIFY" ]; then
 274              curl_extra_args="-k"
 275          fi
 276          max_depth=5
 277          depth=0
 278          head="ref: $remote_name"
 279          while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
 280          do
 281            remote_name_quoted=$(perl -e '
 282              my $u = $ARGV[0];
 283              $u =~ s/^ref:\s*//;
 284              $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
 285              print "$u";
 286          ' "$head")
 287            head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
 288            depth=$( expr \( $depth + 1 \) )
 289          done
 290          expr "z$head" : "z$_x40\$" >/dev/null ||
 291              die "Failed to fetch $remote_name from $remote"
 292          echo >&2 Fetching "$remote_name from $remote" using http
 293          git-http-fetch -v -a "$head" "$remote/" || exit
 294          ;;
 295      rsync://*)
 296          TMP_HEAD="$GIT_DIR/TMP_HEAD"
 297          rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
 298          head=$(git-rev-parse --verify TMP_HEAD)
 299          rm -f "$TMP_HEAD"
 300          test "$rsync_slurped_objects" || {
 301              rsync -av --ignore-existing --exclude info \
 302                  "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
 303
 304              # Look at objects/info/alternates for rsync -- http will
 305              # support it natively and git native ones will do it on
 306              # the remote end.  Not having that file is not a crime.
 307              rsync -q "$remote/objects/info/alternates" \
 308                  "$GIT_DIR/TMP_ALT" 2>/dev/null ||
 309                  rm -f "$GIT_DIR/TMP_ALT"
 310              if test -f "$GIT_DIR/TMP_ALT"
 311              then
 312                  resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
 313                  while read alt
 314                  do
 315                      case "$alt" in 'bad alternate: '*) die "$alt";; esac
 316                      echo >&2 "Getting alternate: $alt"
 317                      rsync -av --ignore-existing --exclude info \
 318                      "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
 319                  done
 320                  rm -f "$GIT_DIR/TMP_ALT"
 321              fi
 322              rsync_slurped_objects=t
 323          }
 324          ;;
 325      *)
 326          # We will do git native transport with just one call later.
 327          continue ;;
 328      esac
 329
 330      append_fetch_head "$head" "$remote" \
 331          "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 332
 333  done
 334
 335  case "$remote" in
 336  http://* | https://* | rsync://* )
 337      ;; # we are already done.
 338  *)
 339    ( : subshell because we muck with IFS
 340      IFS="     $LF"
 341      (
 342          git-fetch-pack $exec $keep --thin "$remote" $rref || echo failed "$remote"
 343      ) |
 344      while read sha1 remote_name
 345      do
 346          case "$sha1" in
 347          failed)
 348                  echo >&2 "Fetch failure: $remote"
 349                  exit 1 ;;
 350          esac
 351          found=
 352          single_force=
 353          for ref in $refs
 354          do
 355              case "$ref" in
 356              +$remote_name:*)
 357                  single_force=t
 358                  not_for_merge=
 359                  found="$ref"
 360                  break ;;
 361              .+$remote_name:*)
 362                  single_force=t
 363                  not_for_merge=t
 364                  found="$ref"
 365                  break ;;
 366              .$remote_name:*)
 367                  not_for_merge=t
 368                  found="$ref"
 369                  break ;;
 370              $remote_name:*)
 371                  not_for_merge=
 372                  found="$ref"
 373                  break ;;
 374              esac
 375          done
 376          local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
 377          append_fetch_head "$sha1" "$remote" \
 378                  "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
 379      done
 380    ) || exit ;;
 381  esac
 382
 383}
 384
 385fetch_main "$reflist"
 386
 387# automated tag following
 388case "$no_tags$tags" in
 389'')
 390        case "$reflist" in
 391        *:refs/*)
 392                # effective only when we are following remote branch
 393                # using local tracking branch.
 394                taglist=$(IFS=" " &&
 395                git-ls-remote $upload_pack --tags "$remote" |
 396                sed -ne 's|^\([0-9a-f]*\)[      ]\(refs/tags/.*\)^{}$|\1 \2|p' |
 397                while read sha1 name
 398                do
 399                        test -f "$GIT_DIR/$name" && continue
 400                        git-check-ref-format "$name" || {
 401                                echo >&2 "warning: tag ${name} ignored"
 402                                continue
 403                        }
 404                        git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
 405                        echo >&2 "Auto-following $name"
 406                        echo ".${name}:${name}"
 407                done)
 408        esac
 409        case "$taglist" in
 410        '') ;;
 411        ?*)
 412                fetch_main "$taglist" ;;
 413        esac
 414esac
 415
 416# If the original head was empty (i.e. no "master" yet), or
 417# if we were told not to worry, we do not have to check.
 418case ",$update_head_ok,$orig_head," in
 419*,, | t,* )
 420        ;;
 421*)
 422        curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
 423        if test "$curr_head" != "$orig_head"
 424        then
 425                git-update-ref HEAD "$orig_head"
 426                die "Cannot fetch into the current branch."
 427        fi
 428        ;;
 429esac